﻿UseSQLiteDatabase()

IncludeFile "Locale.pbi"
Locale::AppLanguage = "de_DE" ;Set default language
Locale::Initialise()
Locale::SelectLanguage()

Global Window_0

;Gadget Variables
Global btnExit, cmbCategory, txtCategory, txtFirst, String_0, txtVar, strEPhrase, txtEPhrase, strFPhrase, txtFPhrase, btnNext, btnPrevious, txtSecond
Global txtLanguage.i, cmbLanguage.i, btnSave.i

;Control Variables
Structure Phrase
  Code.s
  Text.s
EndStructure
Global NewList Phrases.Phrase()  
Global SecondLanguage.s
Global DBID.i, CurrentElement.i

Enumeration FormMenu
  #mnuNew
EndEnumeration

Structure Language
  Title.s
  Code.s
EndStructure
Global Dim Available.Language(0)

Procedure FetchLanguages()
  
  Define ExamDir.i, iLoop.i
  Define FName.s, Criteria.s
    
  iLoop = 0
  ReDim Available(iLoop)
  ExamDir = ExamineDirectory(#PB_Any,GetCurrentDirectory() + "Language Files","*.lng")
  While NextDirectoryEntry(ExamDir)
    type=DirectoryEntryType(ExamDir)
    FName=DirectoryEntryName(ExamDir)
    Available(iLoop)\Code = GetFilePart(FName,#PB_FileSystem_NoExtension) 
    iLoop = iLoop + 1
    ReDim Available(iLoop)
  Wend
  FinishDirectory(ExamDir)
    
  ;Load Languages
  For iLoop = 0 To ArraySize(Available())-1
    If IsImage(imgcnb)
      FreeImage(imgcmb)
    EndIf
    ;imgcmb = LoadImage(#PB_Any,GetCurrentDirectory() + "Language Files\" + Available(iLoop)\Code + ".png")
    DBID = OpenDatabase(#PB_Any,GetCurrentDirectory() + "Language Files\" + Available(iLoop)\Code + ".lng","","")  
    Criteria = "SELECT Title,Code FROM Language;"
    DatabaseQuery(DBID,criteria)
    FirstDatabaseRow(DBID)
    Available(iLoop)\Title = GetDatabaseString(DBID,0)
    FinishDatabaseQuery(DBID)
  Next iLoop
  
EndProcedure 

Procedure LoadCategories()
  
  Define Criteria.s
  Define iLoop.i
  
  ;C:\CD Multi\Manage Files\Language Files
  
  ;Allways English
  DBID = OpenDatabase(#PB_Any,GetCurrentDirectory() + "Language Files\en_GB.lng","","")  
  Criteria  = "SELECT * FROM Category;"
  ClearGadgetItems(cmbCategory)
  DatabaseQuery(DBID,criteria)
  FirstDatabaseRow(DBID)
  AddGadgetItem(cmbCategory,iLoop,GetDatabaseString(DBID,DatabaseColumnIndex(DBID,"Title")))
  SetGadgetItemData(cmbCategory,0,GetDatabaseLong(DBID,DatabaseColumnIndex(DBID,"Category_ID")))
  iLoop = 1
  While NextDatabaseRow(DBID)
    AddGadgetItem(cmbCategory,iLoop,GetDatabaseString(DBID,DatabaseColumnIndex(DBID,"Title")))    
    SetGadgetItemData(cmbCategory,iLoop,GetDatabaseLong(DBID,DatabaseColumnIndex(DBID,"Category_ID")))    
    iLoop = iLoop + 1  
  Wend
  FinishDatabaseQuery(DBID)
  
EndProcedure

Procedure LoadEnglishPhrases(CategoryID.i)
  
  Define Criteria.s
  
  Criteria = "SELECT Key,Phrase From Phrases WHERE Category_ID = " + Str(CategoryID) + " ORDER BY Key ASC;"

  ClearList(Phrases()) 
  DatabaseQuery(DBID,Criteria)
  FirstDatabaseRow(DBID)
  AddElement(Phrases())
  Phrases()\Code = GetDatabaseString(DBID, 0)
  Phrases()\Text = GetDatabaseString(DBID, 1) 
  While NextDatabaseRow(DBID)
    AddElement(Phrases())
    Phrases()\Code = GetDatabaseString(DBID, 0)
    Phrases()\Text = GetDatabaseString(DBID, 1)  
  Wend
  FinishDatabaseQuery(DBID)
 
  CurrentElement = 1
  
EndProcedure 

Procedure ShowPhrase()
  
  Define Criteria.s
  Define DB2ID.i
  
  SetGadgetText(String_0,Phrases()\Code)
  SetGadgetText(strEPhrase,Phrases()\Text)  
  
  If SecondLanguage > ""
    DB2ID = OpenDatabase(#PB_Any,GetCurrentDirectory() + SecondLanguage,"","") 
    Criteria = "SELECT Key,Phrase From Phrases WHERE Key = '" + Phrases()\Code + "';"
    DatabaseQuery(DB2ID,criteria)
    FirstDatabaseRow(DB2ID)
    SetGadgetText(strFPhrase,GetDatabaseString(DB2ID,1))
    FinishDatabaseQuery(DB2ID)
    CloseDatabase(DB2ID)
  EndIf
  
EndProcedure

Procedure SavePhrase()

  Define Criteria.s
  Define DB2ID.i 
  
  If SecondLanguage > ""
    DB2ID = OpenDatabase(#PB_Any,GetCurrentDirectory() + SecondLanguage,"","") 
 
    Criteria = "UPDATE Phrases SET Phrase = '" + GetGadgetText(strFPhrase) + "' Where Key = '" + GetGadgetText(String_0) + "';"
    DatabaseUpdate(DB2ID, Criteria)
    CloseDatabase(DB2ID)
  EndIf
    
EndProcedure

Procedure ErrorHandler()
 
  ErrorMessage$ = "A program error was detected:" + Chr(13) 
  ErrorMessage$ + Chr(13)
  ErrorMessage$ + "Error Message:   " + ErrorMessage()      + Chr(13)
  ErrorMessage$ + "Error Code:      " + Str(ErrorCode())    + Chr(13)  
  ErrorMessage$ + "Code Address:    " + Str(ErrorAddress()) + Chr(13)
 
  If ErrorCode() = #PB_OnError_InvalidMemory   
    ErrorMessage$ + "Target Address:  " + Str(ErrorTargetAddress()) + Chr(13)
  EndIf
 
  If ErrorLine() = -1
    ErrorMessage$ + "Sourcecode line: Not Available" + Chr(13)
  Else
    ErrorMessage$ + "Sourcecode line: " + Str(ErrorLine()) + Chr(13)
    ErrorMessage$ + "Sourcecode file: " + GetFilePart(ErrorFile()) + Chr(13)
  EndIf
 
  MessageRequester("Programme Error", ErrorMessage$)
  End
 
EndProcedure

OnErrorCall(@ErrorHandler())

Window_0 = OpenWindow(#PB_Any, 0, 0, 570, 190, Locale::AP_0001, #PB_Window_SystemMenu| #PB_Window_ScreenCentered)
CreateMenu(0, WindowID(Window_0))
MenuTitle(Locale::CM_0005)
MenuItem(#mnuNew, Locale::CM_0006)
txtCategory = TextGadget(#PB_Any, 10, 10, 100, 20, Locale::AP_0002, #PB_Text_Right)
cmbCategory = ComboBoxGadget(#PB_Any, 130, 10, 140, 20)
txtLanguage = TextGadget(#PB_Any, 250, 10, 100, 20, Locale::AP_0003, #PB_Text_Right)
cmbLanguage = ComboBoxGadget(#PB_Any, 380, 10, 140, 20)
txtFirst = TextGadget(#PB_Any, 130, 40, 100, 20, "English")
String_0 = StringGadget(#PB_Any, 10, 100, 100, 20, "")
txtVar = TextGadget(#PB_Any, 10, 70, 100, 20, Locale::AP_0004)
strEPhrase = StringGadget(#PB_Any, 130, 100, 210, 20, "")
txtEPhrase = TextGadget(#PB_Any, 130, 70, 210, 20, Locale::AP_0005)
strFPhrase = StringGadget(#PB_Any, 350, 100, 210, 20, "")
txtFPhrase = TextGadget(#PB_Any, 350, 70, 210, 20, Locale::AP_0005)
txtSecond = TextGadget(#PB_Any, 350, 40, 100, 20, "")
btnFirst = ButtonGadget(#PB_Any, 130, 130, 25, 25, "|<")
btnPrevious = ButtonGadget(#PB_Any, 160, 130, 25, 25, "<")  
btnNext = ButtonGadget(#PB_Any, 285, 130, 25, 25, ">") 
btnLast = ButtonGadget(#PB_Any, 315, 130, 25, 25, ">|")
btnSave = ButtonGadget(#PB_Any, 360, 130, 90, 25, Locale::CM_0009)
btnExit = ButtonGadget(#PB_Any, 470, 130, 90, 25, Locale::CM_0017)

FetchLanguages()
For iLoop = 0 To ArraySize(Available()) - 1
  AddGadgetItem(cmbLanguage,iLoop, Available(iLoop)\title)
  SetGadgetItemData(cmbLanguage,iLoop,iLoop)
Next
LoadCategories()

Repeat
  Event = WaitWindowEvent()

  Select event
    Case #PB_Event_CloseWindow
      End

    Case #PB_Event_Menu
      Select EventMenu()
        Case #mnuNew
      EndSelect

    Case #PB_Event_Gadget
      Select EventGadget()
          
        Case cmbCategory
          LoadEnglishPhrases(GetGadgetItemData(cmbCategory,GetGadgetState(cmbCategory)))
          FirstElement(Phrases())
          ShowPhrase()
          
        Case cmbLanguage
          SecondLanguage =  "Language Files\" + Available(GetGadgetItemData(cmbLanguage,GetGadgetState(cmbLanguage)))\Code + ".lng"   
          SetGadgetText(txtSecond,Available(GetGadgetItemData(cmbLanguage,GetGadgetState(cmbLanguage)))\Title)
          If GetGadgetText(String_0) > ""
            ShowPhrase()
          EndIf
                    
        Case btnFirst
          FirstElement(Phrases()) 
          If GetGadgetText(String_0) > ""
            ShowPhrase()
          EndIf   

        Case btnPrevious
          PreviousElement(Phrases())
          If GetGadgetText(String_0) > ""
            ShowPhrase()
          EndIf
          
        Case btnNext
          NextElement(Phrases())
          If GetGadgetText(String_0) > ""
            ShowPhrase()
          EndIf          
          
        Case btnLast
          LastElement(Phrases())
          If GetGadgetText(String_0) > ""
            ShowPhrase()
          EndIf           
          
        Case btnSave
          SavePhrase()
          
        Case btnExit
          End
          
      EndSelect
  EndSelect
  
ForEver


; IDE Options = PureBasic 5.42 LTS (Windows - x64)
; CursorPosition = 3
; Folding = A-
; EnableUnicode
; EnableXP